#include <stdio.h>
#include <stdlib.h>

void greska(char *s)
{
	printf("greska: %s\n", s);
	exit(EXIT_FAILURE);
}

int main(int argc, char **argv)
{
	//broj elementata koji se alocira bice
	//prosledjen kao arg. kom. lin.
	
	int x = atoi(argv[1]);
	
	//sada treba da alociramo 2 niza duzine x
	//jedan +1 varijantom, drugi *2 varijantom
	
	int *niz1 = NULL;
	int n1 = 0;
	int n1_alocirano = 0;
	
	//1 2 3 4 5 6
	//n1 = 6
	//n1_alocirano = 8
	
	int *niz2 = NULL;
	int n2 = 0;
	int i;
	int pocetak;
	
	niz1 = malloc(sizeof(int));
	n1_alocirano = 1;
	if(niz1 == NULL)
		greska("malloc");
		
	
	//*2 varijanta
	pocetak = time(NULL);
	for(i = 0; i < x; i++)
	{
		n1++;
		if(n1 > n1_alocirano)
		{
			n1_alocirano *= 2;
			int *tmp = (int*)realloc(niz1, n1_alocirano * sizeof(int));
			if(tmp == NULL)
			{
				free(niz1);
				greska("realloc");
			}
			niz1 = tmp;
		}
		niz1[n1 - 1] = rand();
	}
	printf("*2 varijanta %d sekundi\n", time(NULL) - pocetak);
	
	pocetak = time(NULL);
	for(i = 0; i < x; i++)
	{
		n2++;
		int *tmp = (int*)realloc(niz2, n2 * sizeof(int));
		if(tmp == NULL)
		{
			free(niz2);
			greska("realloc");
		}
		niz2 = tmp;
		niz2[n2 - 1] = rand();
	}
	printf("+1 varijanta %d sekundi\n", time(NULL) - pocetak);

}